Unit IA202_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IA202(LU :Integer; N :Integer; var H :Array of Real;
                var R :Array of Real; var B :Array of Real);

implementation

procedure IA202(LU :Integer; N :Integer; var H :Array of Real;
                var R :Array of Real; var B :Array of Real);
var
K,K1,K2,K4,K5,N1,N2,J,J0,J1,J2,J4,J5 :Integer;
S,W :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
K := N+N;
K1 := K+N;
K4 := 6*N;
K5 := K4+N+1;
S := 0.0;
N1 := N-1;
for J:=1 to N1 do
 begin
  J1 := N-J;
  J2 := K+1-J;
  J0 := K+J1;
  S := S+B[J2-1];
_1:
  B[J0-1] := 2.0*H[J1-1]*S;
 end;
if ( LU ) < 0
 then goto _3
 else if ( LU ) > 0
       then goto _3
       else goto _2;
_2:
J0 := K+N;
N1 := N;
B[J0-1] := 2.0*(S+B[N+0]);
_3:
for J:=1 to N1 do
 begin
  if ( R[J-1] ) < 0
   then goto _6
   else if ( R[J-1] ) > 0
         then goto _6
         else goto _4;
_4:
  J1 := K1+J;
  J0 := K+J;
_5:
  B[J1-1] := B[J0-1];
 end;
goto _9;
_6:
B[K4+0] := 0.0;
B[K5+0] := 0.0;
for J:=1 to N1 do
 begin
  J0 := K+J;
  J4 := K4+J;
  J5 := K5+J;
  W := R[J+0]+R[J-1]*(1.0-B[J4-1])+1.0;
  B[J4+0] := R[J+0]/W;
  B[J5+0] := (B[J0-1]+R[J-1]*B[J5-1])/W;
_7:
 end;
K2 := K1+N1;
J5 := K5+N1+1;
B[K2-1] := B[J5-1];
N2 := N1-1;
for J:=1 to N2 do
 begin
  J1 := K2-J+1;
  J4 := K4+N1-J+1;
  J5 := K5+N1-J+1;
_8:
  B[J1-2] := B[J4-1]*B[J1-1]+B[J5-1];
 end;
_9:
end;

end.
